#include "mot.h"
#include "INavigateurMots.h"

#include <fstream>
using std::basic_ifstream;
#include <iostream>
using std::basic_ostream;
using std::cerr;
using std::cout;
using std::endl;
#include <memory>
using std::auto_ptr;

template <class C>
   void bouffer_brut(const basic_string<C> &nom, basic_ostream<C> &sortie)
   {
      auto_ptr<INavigateurMots<C> > p (FabriqueNavigateurMots<C>::Creer());
      basic_ifstream<C> source (nom.c_str ());
      p->associer (&source);
      try
      {
         for (;;)
            sortie << p->prochain() << endl;
      }
      catch (SourceInvalide)
      {
         sortie << "Problme de consultation du flux" << endl;
      }
      catch (SourceEpuisee)
      {
         // ok
      }
      catch (...)
      {
         sortie << "Brrr... erreur inconnue" << endl;
      }
   }


using std::wstring;
using std::basic_ofstream;

int main ()
{
   const wstring SOURCE = L"source.xml";
   //const wstring SOURCE = L"principal.cpp";
   basic_ofstream<wchar_t> dump(L"log.txt");
   bouffer_brut (SOURCE, dump);
   // et voil!
}
